#!/usr/local/bin/perl
print "Content-type: text/html\n\n";

# The above two lines just have to be there, ok!

#########################
# Decode input (do not change this part!)

if ($ENV{'REQUEST_METHOD'} eq "GET") {
  $in = $ENV{'QUERY_STRING'};
} elsif ($ENV{'REQUEST_METHOD'} eq "POST") {
 for ($i = 0; $i < $ENV{'CONTENT_LENGTH'}; $i++) {
    $in .= getc;
  }
} 
@in = split(/&/,$in);
 
foreach $i (0 .. $#in) {
  # Convert plus's to spaces
  $in[$i] =~ s/\+/ /g;
 
  # Convert %XX from hex numbers to alphanumeric
  $in[$i] =~ s/%(..)/pack("c",hex($1))/ge;
  
  # Split into key and value.
  $loc = index($in[$i],"=");
  $key = substr($in[$i],0,$loc);
  $val = substr($in[$i],$loc+1);
  $in{$key} .= '\0' if (defined($in{$key})); # \0 is the multiple separator
  $in{$key} .= $val;
}

# (end of decoding bit)
#
# Input data can now be found in the following variables:
#    $in{name}, $in{url}, $in{name}, $in{message}
#
# This is still relatively "raw" data and should be further evaluated before
# it is approved as input to the guestbook. How much such evaluation is
# needed? That's up to you, but you should keep the "no html" rules.
#
#############################################################################

##############################################
#
# Input evaluation
#
# Removing ability for visitor to do evil HTML things
#
# The
#  $variable =~ s/first_string/second_string/g;
# things are "replace" commands. They replace first_string with
# seocond_string in $variable.
#
# Other possible evaluations:
#          * Max input size
#          * Can "x@.@x" be a valid email address?
#          * Homepage URLs should begin with "http://".
#          * "Get a name!" message if user has not filled in a name.

if ($in{name})   # name is used as "text", so < and & need encoding 
{
    $in{name} =~ s/&/&amp;/g;
    $in{name} =~ s/</&lt;/g;
}
if ($in{url})    # url is used in an attribute, so <, >, & and " need encoding
{
    $in{url} =~ s/&/&amp;/g;
    $in{url} =~ s/</&lt;/g;
    $in{url} =~ s/>/&gt;/g;
    $in{url} =~ s/"/&quot;/g;
}
if ($in{mail})   # mail is used in an attribute, so <, >, & and " need encoding
{
    $in{mail} =~ s/&/&amp;/g;
    $in{mail} =~ s/</&lt;/g;
    $in{mail} =~ s/>/&gt;/g;
    $in{mail} =~ s/"/&quot;/g;
}
if ($in{message})   # name is used as "text", so < and & need encoding
{
    $in{message} =~ s/&/&amp;/g;
    $in{message} =~ s/</&lt;/g;
}

# (end of input evaluation)
##########################################

###################
# Write new block to guestbook

open(FIL,">>guest.book");    # Open file guest.book for "extending" (writing to
                             # the end of the file while keeping old content)
$a=localtime(time);  # What time is it? (used in the time stamp on each entry)

if (!$in{name}) # Could be replaced with a "Get a name and try again!" message.
{
    $in{name} = "Somebody";
}

print FIL "<p><EM> At $a </EM>";
if ($in{url}){   # Link to homepage if the user has filled in a homepage
    print FIL "<a href=\"$in{url}\">$in{name}</a> ";
}
else
{
    print FIL "$in{name}";
}	
    
if ($in{mail}){  # Link to email address if user has filled in an email address
    print FIL "(<a href=\"mailto:$in{mail}\">$in{mail}</a>)";
}	
print FIL " wrote: <BR>$in{message}<HR>\n";
close FIL;


########################
# Show guestbook (this part is identical to "showbook.cgi")

print "<!DOCTYPE HTML PUBLIC \"-//W3C//DTD HTML 4.0 Transitional//EN\" \"http://www.w3.org/TR/REC-html40/loose.dtd\">";
print "<HTML><HEAD><TITLE>My Guestbook</TITLE><base target=\"_top\">";
print "<LINK REL=\"StyleSheet\" href=\"style.css\" type=\"text/css\">";
print "</HEAD><BODY>";
print "<div class=\"content\">";

print "<h1>My Guestbook</h1>";

print "<p><a href=\"../\">to my homepage</a><hr>";

open(FIL,"guest.book");     # Open file guest.book for reading
while($_=<FIL>){ print; }   # Print file contents to output
close FIL;
	
print "</div></body></html>";



